## Threads

Threads

## Functions

#define | GDK_THREADS_ENTER
#define | GDK_THREADS_LEAVE
void | gdk_threads_init ()
void | gdk_threads_enter ()
void | gdk_threads_leave ()
void | gdk_threads_set_lock_functions ()
guint | gdk_threads_add_idle ()
guint | gdk_threads_add_idle_full ()
guint | gdk_threads_add_timeout ()
guint | gdk_threads_add_timeout_full ()
guint | gdk_threads_add_timeout_seconds ()
guint | gdk_threads_add_timeout_seconds_full ()

## Types and Values

extern GMutex * | gdk_threads_mutex

## Includes

    #include <gdk/gdk.h>

## Description

## Functions

### GDK_THREADS_ENTER

    #define             GDK_THREADS_ENTER()

### GDK_THREADS_LEAVE

    #define             GDK_THREADS_LEAVE()

### gdk_threads_init ()

    void
    gdk_threads_init (void);

Initializes GDK so that it can be used from multiple threads in conjunction with `gdk_threads_enter()` and `gdk_threads_leave()`. `g_thread_init()` must be called previous to this function.

This call must be made before any use of the main loop from GTK+; to be safe, call it before `gtk_init()`.

### gdk_threads_enter ()

    void
    gdk_threads_enter (void);

### gdk_threads_leave ()

    void
    gdk_threads_leave (void);

### gdk_threads_set_lock_functions ()

    void
    gdk_threads_set_lock_functions (GCallback enter_fn,
                                    GCallback leave_fn);

Allows the application to replace the standard method that GDK uses to protect its data structures. Normally, GDK creates a single GMutex that is locked by `gdk_threads_enter()`, and released by `gdk_threads_leave()`; using this function an application provides, instead, a function `enter_fn` that is called by `gdk_threads_enter()` and a function `leave_fn` that is called by `gdk_threads_leave()`.

The functions must provide at least same locking functionality as the default implementation, but can also do extra application specific processing.

As an example, consider an application that has its own recursive lock that when held, holds the GTK+ lock as well. When GTK+ unlocks the GTK+ lock when entering a recursive main loop, the application must temporarily release its lock as well.

Most threaded GTK+ apps won't need to use this method.

This method must be called before `gdk_threads_init()`, and cannot be called multiple times.

#### Parameters

enter_fn | function called to guard GDK |
leave_fn | function called to release the guard |

Since: 2.4

### gdk_threads_add_idle ()

    guint
    gdk_threads_add_idle (GSourceFunc function,
                          gpointer data);

A wrapper for the common usage of `gdk_threads_add_idle_full()` assigning the default priority, G_PRIORITY_DEFAULT_IDLE.

See `gdk_threads_add_idle_full()`.

#### Parameters

function | function to call |
data | data to pass to `function` |

#### Returns

the ID (greater than 0) of the event source.

Since: 2.12

### gdk_threads_add_idle_full ()

    guint
    gdk_threads_add_idle_full (gint priority,
                               GSourceFunc function,
                               gpointer data,
                               GDestroyNotify notify);

Adds a function to be called whenever there are no higher priority events pending. If the function returns `FALSE` it is automatically removed from the list of event sources and will not be called again.

This variant of `g_idle_add_full()` calls `function` with the GDK lock held. It can be thought of a MT-safe version for GTK+ widgets for the following use case, where you have to worry about `idle_callback()` running in thread A and accessing `self` after it has been finalized in thread B:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29

    static gboolean
    idle_callback (gpointer data)
    {
       /* gdk_threads_enter(); would be needed for g_idle_add() */

       SomeWidget *self = data;
       /* do stuff with self */

       self->idle_id = 0;

       /* gdk_threads_leave(); would be needed for g_idle_add() */
       return FALSE;
    }

    static void
    some_widget_do_stuff_later (SomeWidget *self)
    {
       self->idle_id = gdk_threads_add_idle (idle_callback, self)
       /* using g_idle_add() here would require thread protection in the callback */
    }

    static void
    some_widget_finalize (GObject *object)
    {
       SomeWidget *self = SOME_WIDGET (object);
       if (self->idle_id)
         g_source_remove (self->idle_id);
       G_OBJECT_CLASS (parent_class)->finalize (object);
    }

#### Parameters

priority | the priority of the idle source. Typically this will be in the range btweeen G_PRIORITY_DEFAULT_IDLE and G_PRIORITY_HIGH_IDLE |
function | function to call |
data | data to pass to `function` |
notify | function to call when the idle is removed, or `NULL`. | [allow-none]

#### Returns

the ID (greater than 0) of the event source.

Since: 2.12

### gdk_threads_add_timeout ()

    guint
    gdk_threads_add_timeout (guint interval,
                             GSourceFunc function,
                             gpointer data);

A wrapper for the common usage of `gdk_threads_add_timeout_full()` assigning the default priority, G_PRIORITY_DEFAULT.

See `gdk_threads_add_timeout_full()`.

#### Parameters

interval | the time between calls to the function, in milliseconds (1/1000ths of a second) |
function | function to call |
data | data to pass to `function` |

#### Returns

the ID (greater than 0) of the event source.

Since: 2.12

### gdk_threads_add_timeout_full ()

    guint
    gdk_threads_add_timeout_full (gint priority,
                                  guint interval,
                                  GSourceFunc function,
                                  gpointer data,
                                  GDestroyNotify notify);

Sets a function to be called at regular intervals holding the GDK lock, with the given priority. The function is called repeatedly until it returns `FALSE`, at which point the timeout is automatically destroyed and the function will not be called again. The `notify` function is called when the timeout is destroyed. The first call to the function will be at the end of the first `interval` .

Note that timeout functions may be delayed, due to the processing of other event sources. Thus they should not be relied on for precise timing. After each call to the timeout function, the time of the next timeout is recalculated based on the current time and the given interval (it does not try to 'catch up' time lost in delays).

This variant of `g_timeout_add_full()` can be thought of a MT-safe version for GTK+ widgets for the following use case:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25

    static gboolean timeout_callback (gpointer data)
    {
       SomeWidget *self = data;

       /* do stuff with self */

       self->timeout_id = 0;

       return FALSE;
    }

    static void some_widget_do_stuff_later (SomeWidget *self)
    {
       self->timeout_id = g_timeout_add (timeout_callback, self)
    }

    static void some_widget_finalize (GObject *object)
    {
       SomeWidget *self = SOME_WIDGET (object);

       if (self->timeout_id)
         g_source_remove (self->timeout_id);

       G_OBJECT_CLASS (parent_class)->finalize (object);
    }

#### Parameters

priority | the priority of the timeout source. Typically this will be in the range between G_PRIORITY_DEFAULT_IDLE and G_PRIORITY_HIGH_IDLE. |
interval | the time between calls to the function, in milliseconds (1/1000ths of a second) |
function | function to call |
data | data to pass to `function` |
notify | function to call when the timeout is removed, or `NULL`. | [allow-none]

#### Returns

the ID (greater than 0) of the event source.

Since: 2.12

### gdk_threads_add_timeout_seconds ()

    guint
    gdk_threads_add_timeout_seconds (guint interval,
                                     GSourceFunc function,
                                     gpointer data);

A wrapper for the common usage of `gdk_threads_add_timeout_seconds_full()` assigning the default priority, G_PRIORITY_DEFAULT.

For details, see `gdk_threads_add_timeout_full()`.

#### Parameters

interval | the time between calls to the function, in seconds |
function | function to call |
data | data to pass to `function` |

#### Returns

the ID (greater than 0) of the event source.

Since: 2.14

### gdk_threads_add_timeout_seconds_full ()

    guint
    gdk_threads_add_timeout_seconds_full (gint priority,
                                          guint interval,
                                          GSourceFunc function,
                                          gpointer data,
                                          GDestroyNotify notify);

A variant of `gdk_threads_add_timout_full()` with second-granularity. See `g_timeout_add_seconds_full()` for a discussion of why it is a good idea to use this function if you don't need finer granularity.

#### Parameters

priority | the priority of the timeout source. Typically this will be in the range between G_PRIORITY_DEFAULT_IDLE and G_PRIORITY_HIGH_IDLE. |
interval | the time between calls to the function, in seconds |
function | function to call |
data | data to pass to `function` |
notify | function to call when the timeout is removed, or `NULL`. | [allow-none]

#### Returns

the ID (greater than 0) of the event source.

Since: 2.14

## Types and Values

### gdk_threads_mutex

    extern GMutex *gdk_threads_mutex; /* private */

`gdk_threads_mutex` is deprecated and should not be used in newly-written code.